<template>
  <div class="transition">
    <ModuleHeroSlider
      v-if="itemsTransition"
      ref="transitionLeft"
      class="slider left"
      direction="up"
      :speed="700"
      :items="itemsTransition"
      :loop="true"
      @afterChange="afterChangeLeft"
    />
    <ModuleHeroSlider
      v-if="itemsTransition"
      ref="transitionRight"
      class="slider right"
      direction="down"
      :speed="700"
      :items="itemsTransition"
      :loop="true"
      @afterChange="afterChangeRight"
    />
  </div>
</template>

<script>
export default {
  data() {
    return {
      change: false,
      leftHide: true,
      rightHide: true,
      itemsTransition: [
        {
          color: '#000000',
        },
        {
          color: 'rgba(0,0,0,0)',
        },
      ],
    }
  },
  mounted() {
    this.onHideDone()
  },
  methods: {
    hide(items) {
      if (this.change) return

      this.change = true
      if (this.$refs.transitionLeft) this.$refs.transitionLeft.next()
      if (this.$refs.transitionRight) this.$refs.transitionRight.next()
    },

    show() {
      if (this.$refs.transitionLeft) this.$refs.transitionLeft.next()
      if (this.$refs.transitionRight) this.$refs.transitionRight.next()
      this.change = false
    },

    afterChangeLeft() {
      this.leftHide = !this.leftHide
      this.checkHideShow()
    },
    afterChangeRight() {
      this.rightHide = !this.rightHide
      this.checkHideShow()
    },

    checkHideShow() {
      if (this.leftHide && this.rightHide) this.onHideDone()
      if (!this.leftHide && !this.rightHide) this.onShowDone()
    },

    onHideDone() {
      this.$emit('onHideDone')
    },
    onShowDone() {
      this.$emit('onShowDone')
    },
  },
}
</script>

<style lang="scss" scoped>
.transition {
  width: 100vw;
  height: 100vh;

  .slider {
    @apply absolute;

    @apply h-full;

    mask-repeat: no-repeat;
    mask-size: 100% 100%;

    &.left {
      left: 0;
      width: 55.3vw;

      mask-image: url('/SVG/mask-left.svg');
    }

    &.right {
      width: 55.35vw;
      right: 0px;
      mask-image: url('/SVG/mask-right.svg');
    }
  }
}
</style>
